function Banner (el,imagesAndUrl,JSON) {
  if(el==null || imagesAndUrl == null) {
    console.log("请传入节点或者图片数据及链接！");
    return;
  }
  this.el = el;
  this.imagesAndUrl = imagesAndUrl;
  this.timer = JSON.transitionTime || 400;
  this.intervalTime = JSON.intervalTime || 3000;

  // 定义一些全局变量
  this.index = 1; 
  this.animationMark = false;
  this.init();
}

// init => 添加dom节点,初始化界面
Banner.prototype.init = function () {
  // 动态添加一些css样式
  let cssStr = `.banner .banner-list {width: ${(this.imagesAndUrl.length+2)*this.el.clientWidth}px;}.banner .banner-list .banner-item {width:${this.el.clientWidth}px;}`
  let styleNode = document.createElement('style');
  styleNode.innerText = cssStr;
  document.head.appendChild(styleNode)

  var html = `<div class="banner">
                <div class="banner-list" style="left:-${this.el.clientWidth}px">`;
  
  // 添加显示图片区域
  // 无缝轮播，收尾多加一张
  let temStr = `<div class="banner-item">
          <a href="${this.imagesAndUrl[this.imagesAndUrl.length-1].linkHref==null?"#":this.imagesAndUrl[this.imagesAndUrl.length-1].linkHref}"><img src="${this.imagesAndUrl[this.imagesAndUrl.length-1].imgSrc}" alt=""></a>
        </div>`
  
  this.imagesAndUrl.map( item => {
    temStr += `<div class="banner-item">
                  <a href="${item.linkHref==null?"#":item.linkHref}"><img src="${item.imgSrc}" alt=""></a>
              </div>`
  })
  temStr += `<div class="banner-item">
              <a href="${this.imagesAndUrl[0].linkHref==null?"#":this.imagesAndUrl[0].linkHref}"><img src="${this.imagesAndUrl[0].imgSrc}" alt=""></a>
            </div>`
  html += temStr + "</div>";

  temStr = `<div class="banner-tool">
              <div class="banner-spot banner-spot-active"></div>`;
  // 添加下面小圆点
  for(let i=1,len=this.imagesAndUrl.length;i<len;i++){
    temStr += `<div class="banner-spot"></div>`;
  }
  html += temStr + "</div>"

  // 添加左右2边按钮
  temStr = `<div class="banner-btn banner-btn-left"><</div>
            <div class="banner-btn banner-btn-right">></div>`

  html += temStr;

  this.el.innerHTML += html + "</div>";

  // 调用绑定事件
  this.bindEvent();
}

// bindEvent => 绑定节点事件/自动轮播开启事件
Banner.prototype.bindEvent = function () {
  // 获取要用到的节点信息
  this.banner = this.el.getElementsByClassName('banner')[0];
  this.bannerList = this.el.getElementsByClassName('banner-list')[0];
  this.bannerTool = this.el.getElementsByClassName('banner-tool')[0];
  this.bannerSpot = this.el.getElementsByClassName('banner-spot');
  this.bannerBtnLeft = this.el.getElementsByClassName('banner-btn-left')[0];
  this.bannerBtnRight = this.el.getElementsByClassName('banner-btn-right')[0];

  
  // 左右按钮 事件监听 
  this.bannerBtnLeft.addEventListener('click', () => {
    if(this.animationMark) return;
    this.index--;
    this.render();
  });
  this.bannerBtnRight.addEventListener('click', () => {
    if(this.animationMark) return;
    this.index++;
    this.render();
  });

  // 下面小圆点点击事件监听
  this.bannerTool.addEventListener('click',e => {
    let obj = e.target;
    if(obj.className != "banner-spot") return;
    this.spotClick(obj);
  })

  // 开启自动轮播
  var timer = setInterval(autoPlay.bind(this),this.intervalTime);

  this.el.addEventListener("mouseover",() => {
    clearInterval(timer);
  })

  this.el.addEventListener("mouseout",() => {
    timer = setInterval(autoPlay.bind(this),this.intervalTime);
  })

  // 移动端手指滑动
  let stratPointX = 0;
  let offsetX = 0;

 /* var startx = 0; // 记录开始位置
   var starty = 0;
   var movex=0;
   var movey=0;
   var xx=0;
   var yy=0;*/
  this.el.addEventListener("touchstart", (e) => {
    // 清楚定时器，因为移动端不能监听到Mouseover时间
    clearInterval(timer);

    stratPointX = e.changedTouches[0].pageX;
    offsetX = this.bannerList.offsetLeft;
    this.animationMark = true;


	/*startx = e.touches[0].pageX; // 记录位置
	starty = e.touches[0].pageY;;// 记录位置*/
  })
  this.el.addEventListener("touchmove", (e) => {
   let disX = e.changedTouches[0].pageX - stratPointX;
    let left = offsetX + disX;

    this.bannerList.style.transitionProperty = 'none';
    this.bannerList.style.left = left + 'px';
	//alert(left);

	/*movex = e.changedTouches[0].pageX;
	 movey = e.changedTouches[0].pageY;
	 xx = movex - startx;
	 yy = movey - starty;
	 this.animationMark = false;
	//alert(movex+'pp'+startx);
	if (xx > 0 && Math.abs(movex)>5 ) {
		if(this.animationMark) return;
        this.index--;
        this.render();
       // alert(this.index);
		}else{
    if (xx < 0 && Math.abs(movex)>5) {
		if(this.animationMark) return;
        this.index++;
       this.render();
	  // alert(this.index);
	}
   }*/

  })
  this.el.addEventListener("touchend", () => {
    let left = this.bannerList.offsetLeft;
    // 判断正在滚动的图片距离左右图片的远近，
   this.index = Math.round(-left/this.el.clientWidth);
	//alert(left+'&'+stratPointX);
    this.animationMark = false;
    // 开启定时器
    timer = setInterval(autoPlay.bind(this),this.intervalTime);

    this.render();
  })

  
  // 封装自动轮播
  function autoPlay () {
    if(this.animationMark) return;
    this.index++;
    this.render();
  }
}

// render => 根据index的值，渲染当前要显示的界面
Banner.prototype.render = function () {
  if(this.animationMark) return;

  this.animationMark = true;
  // 修改bannerList 的left值
  this.bannerList.style.left = (-1)*this.el.clientWidth*this.index + 'px';
  this.bannerList.style.transition = 'left ' + this.timer/1000 + 's';

  setTimeout(() => {
    // 添加判断，防止出界
    if(this.index <= 0){
      this.bannerList.style.transitionProperty = 'none';
      this.index = this.imagesAndUrl.length;
      this.bannerList.style.left = (-1)*this.el.clientWidth*this.index + 'px';
    }else if (this.index > this.imagesAndUrl.length){ 
      this.bannerList.style.transitionProperty = 'none';
      this.index = 1;
      this.bannerList.style.left = (-1)*this.el.clientWidth*this.index + 'px';
    }
    this.animationMark = false;
  },this.timer)

  this.renderSpot();
}

// renderSpot => 渲染最下面的小圆点
Banner.prototype.renderSpot = function () {
  let flag = this.index;
  if(this.index <= 0){
    flag = this.imagesAndUrl.length;
  }else if(this.index > this.imagesAndUrl.length){
    flag = 1;
  }

  for(let i=0,len=this.bannerSpot.length;i<len;i++){
    if(i==(flag-1)){
      this.bannerSpot[i].className = "banner-spot banner-spot-active";
    }else{
      this.bannerSpot[i].className = "banner-spot";
    }
  }
}

// spotClick => 下面小圆点点击事件
Banner.prototype.spotClick = function (obj) {
  for(let i=0,len=this.bannerSpot.length;i<len;i++){
    if(this.bannerSpot[i] === obj){
      this.index = i+1;
      this.render();
      break;
    }
  }
}

// 如果是在vue的环境下使用，取消下面的注释
// module.exports = Banner;